part of tecfy_core_client_package;

class EntityFilter extends BaseModel {
  Property? property;
  String? propertyName;

  /// E  :  equal
  /// NE :  not equal
  /// GE :  Greater Than or equal
  /// G  :  Greater Than
  /// LE : Less Than or Equal
  /// L  : Less Than
  /// C  : Contain
  /// NC :  Not Contain
  /// LIKE :
  /// NLIKE:
  late String? operatorId;

  /// value
  late dynamic value;

  EntityFilter(
      {this.property, this.operatorId, this.value, this.propertyName}) {
    if (operatorId?.isEmpty ?? false) operatorId = 'E';
  }

  @override
  String get displayName => value.toString();

  @override
  String get idValue => value.toString();

  toJson() {
    return {
      'operator': operatorId,
      'value': value != null && value is DateTime
          ? intl.DateFormat("yyyy-MM-ddTHH:mm:ss").format(value)
          : value,
      //'propertyId': EntityService.upperFirst(propertyName ?? property.dbName)
      'propertyId': propertyName ?? property?.dbName ?? ''
    };
  }
}
